#if !defined(win32fe_CompilerFE_h_)
#define win32fe_CompilerFE_h_

#include "toolfe.h"

namespace win32fe {

  class compiler : public tool {
  public:
    compiler();
    virtual ~compiler() {}
    virtual int Parse(void);
    virtual int Execute(void);
  protected:
    virtual int Compile(void);
    virtual int Link(void);
    virtual void Help(void);

    virtual void FoundD(win32fe::LI &);
    virtual void FoundI(win32fe::LI &);
    virtual void FoundL(win32fe::LI &);
    virtual void Foundh(win32fe::LI &);
    virtual void Foundc(win32fe::LI &);
    virtual void Foundl(win32fe::LI &);
    virtual void Foundo(win32fe::LI &);
    virtual void FoundUnknown(win32fe::LI &);

    virtual void AddSystemInfo(void);
    virtual void AddPaths(void) {}
    virtual void AddSystemInclude(void);
    virtual void AddSystemLib(void);
    virtual void DisplayVersion(void);
    virtual bool IsAKnownTool(void);
    virtual void FixOutput(void);

    std::string OptionTags;
    std::list<std::string> compilearg;
    std::list<std::string> linkarg;

    std::string compileoutflag;
    std::string linkoutflag;
    win32fe::LI OutputFlag;
  private:
    typedef void (win32fe::compiler::*ptm)(win32fe::LI &);
    std::map<char,ptm> Options;
  };

}

#endif
